import numpy as np
cimport numpy as np


def cython_is_flippable_in_direction(np.ndarray state, int x, int y, str player, int dx, int dy):
        cdef str opponent
        cdef int p_x, p_y
        if player == 'B':
            opponent = 'W'
        else:
            opponent = 'B'
        p_x = x + dx
        p_y = y + dy
        if p_x >0 and p_y >0 and p_x < 8 and p_y < 8 and state[p_x, p_y] == opponent:
            p_x += dx
            p_y += dy
            while p_x >0 and p_y >0 and p_x < 8 and p_y < 8 and state[p_x - dx, p_y - dy] == opponent:
                if state[p_x, p_y] == player:
                    return 1 == 1
                p_x += dx
                p_y += dy

        return 1 == 0

def cython_compute_num_regions(np.ndarray state, str player):
    cdef np.ndarray temp
    cdef int i, j, x, y, dx, dy
    cdef int num_white_regions = 0

    temp = np.copy(state)

    for i in range(8):
        for j in range(8):
            if temp[i][j] == player:
                for dx in range(-1, 2):
                    for dy in range(-1, 2):
                        if dx != 0 or dy != 0:
                            x = i + dx
                            y = j + dy
                            if x > 0 and y > 0 and x < 8 and y < 8 and temp[x, y] == player:
                                while x > 0 and y > 0 and x < 8 and y < 8 and temp[x, y] == player:
                                    temp[x, y] = "X"
                                    x += dx
                                    y += dy
                                    break
                temp[i, j] = "X"
                num_white_regions += 1
    return num_white_regions
